IRremoteESP8266: IRTrotecESP Class Reference

IRremoteESP8266

Public Member Functions | Static Public Member Functions | Private Member Functions | Static Private Member Functions | Private Attributes | List of all members
IRTrotecESP Class Reference

Class for handling detailed Trotec A/C messages. More...

`#include <ir_Trotec.h>`

Collaboration diagram for IRTrotecESP:
[legend]

## Public Member Functions

| IRTrotecESP (const uint16_t pin, const bool inverted=false, const bool use_modulation=true)
| Class constructor. More...
void | send (const uint16_t repeat=kTrotecDefaultRepeat)
| Send the current internal state as an IR message. More...
int8_t | calibrate (void)
| Run the calibration to calculate uSec timing offsets for this platform. More...
void | begin (void)
| Set up hardware to be able to send a message. More...
void | stateReset (void)
| Reset the state of the remote to a known good state/sequence. More...
void | on (void)
| Set the requested power state of the A/C to on. More...
void | off (void)
| Set the requested power state of the A/C to off. More...
void | setPower (const bool state)
| Change the power setting. More...
bool | getPower (void)
| Get the value of the current power setting. More...
void | setTemp (const uint8_t celsius)
| Set the temperature. More...
uint8_t | getTemp (void)
| Get the current temperature setting. More...
void | setSpeed (const uint8_t fan)
| Set the speed of the fan. More...
uint8_t | getSpeed (void)
| Get the current fan speed setting. More...
uint8_t | getMode (void)
| Get the operating mode setting of the A/C. More...
void | setMode (const uint8_t mode)
| Set the operating mode of the A/C. More...
bool | getSleep (void)
| Get the Sleep setting of the A/C. More...
void | setSleep (const bool on)
| Set the Sleep setting of the A/C. More...
uint8_t | getTimer (void)
| Get the timer time in nr. of Hours. More...
void | setTimer (const uint8_t timer)
| Set the timer time in nr. of Hours. More...
uint8_t * | getRaw (void)
| Get a PTR to the internal state/code for this protocol. More...
void | setRaw (const uint8_t state[])
| Set the internal state from a valid code for this protocol. More...
uint8_t | convertMode (const stdAc::opmode_t mode)
| Convert a stdAc::opmode_t enum into its native mode. More...
uint8_t | convertFan (const stdAc::fanspeed_t speed)
| Convert a stdAc::fanspeed_t enum into it's native speed. More...
stdAc::state_t | toCommon (void)
| Convert the current internal state into its stdAc::state_t equivalent. More...
String | toString (void)
| Convert the current internal state into a human readable string. More...

## Static Public Member Functions

static bool | validChecksum (const uint8_t state[], const uint16_t length=kTrotecStateLength)
| Verify the checksum is valid for a given state. More...
static stdAc::opmode_t | toCommonMode (const uint8_t mode)
| Convert a native mode into its stdAc equivalent. More...
static stdAc::fanspeed_t | toCommonFanSpeed (const uint8_t speed)
| Convert a native fan speed into its stdAc equivalent. More...

## Private Member Functions

void | checksum (void)
| Calculate & set the checksum for the current internal state of the remote. More...

## Static Private Member Functions

static uint8_t | calcChecksum (const uint8_t state[], const uint16_t length=kTrotecStateLength)
| Calculate the checksum for a given state. More...

## Private Attributes

IRsend | _irsend
| Instance of the IR send class. More...
uint8_t | remote_state [kTrotecStateLength]
| Remote state in IR code form. More...

## Detailed Description

Class for handling detailed Trotec A/C messages.

## Constructor & Destructor Documentation

## ◆ IRTrotecESP()

IRTrotecESP::IRTrotecESP | ( | const uint16_t | pin,
|  | const bool | inverted = `false`,
|  | const bool | use_modulation = `true`
| ) |  |

explicit

Class constructor.

Parameters

  [in] | pin | GPIO to be used when sending.
  [in] | inverted | Is the output signal to be inverted?
  [in] | use_modulation | Is frequency modulation to be used?

## Member Function Documentation

## ◆ begin()

void IRTrotecESP::begin | ( | void |  | ) |

Set up hardware to be able to send a message.

## ◆ calcChecksum()

uint8_t IRTrotecESP::calcChecksum | ( | const uint8_t | state[],
|  | const uint16_t | length = `kTrotecStateLength`
| ) |  |

staticprivate

Calculate the checksum for a given state.

Parameters

  [in] | state | The array to calc the checksum of.
  [in] | length | The length/size of the array.

Returns
  The calculated checksum value.

## ◆ calibrate()

int8_t IRTrotecESP::calibrate | ( | void |  | ) |

inline

Run the calibration to calculate uSec timing offsets for this platform.

Returns
  The uSec timing offset needed per modulation of the IR Led.

Note
  This will produce a 65ms IR signal pulse at 38kHz. Only ever needs to be run once per object instantiation, if at all.

## ◆ checksum()

void IRTrotecESP::checksum | ( | void |  | ) |

private

Calculate & set the checksum for the current internal state of the remote.

## ◆ convertFan()

uint8_t IRTrotecESP::convertFan | ( | const stdAc::fanspeed_t | speed | ) |

Convert a stdAc::fanspeed_t enum into it's native speed.

Parameters

  [in] | speed | The enum to be converted.

Returns
  The native equivalent of the enum.

## ◆ convertMode()

uint8_t IRTrotecESP::convertMode | ( | const stdAc::opmode_t | mode | ) |

Convert a stdAc::opmode_t enum into its native mode.

Parameters

  [in] | mode | The enum to be converted.

Returns
  The native equivalent of the enum.

## ◆ getMode()

uint8_t IRTrotecESP::getMode | ( | void |  | ) |

Get the operating mode setting of the A/C.

Returns
  The current operating mode setting.

## ◆ getPower()

bool IRTrotecESP::getPower | ( | void |  | ) |

Get the value of the current power setting.

Returns
  true, the setting is on. false, the setting is off.

## ◆ getRaw()

uint8_t * IRTrotecESP::getRaw | ( | void |  | ) |

Get a PTR to the internal state/code for this protocol.

Returns
  PTR to a code for this protocol based on the current internal state.

## ◆ getSleep()

bool IRTrotecESP::getSleep | ( | void |  | ) |

Get the Sleep setting of the A/C.

Returns
  true, the setting is on. false, the setting is off.

## ◆ getSpeed()

uint8_t IRTrotecESP::getSpeed | ( | void |  | ) |

Get the current fan speed setting.

Returns
  The current fan speed/mode.

## ◆ getTemp()

uint8_t IRTrotecESP::getTemp | ( | void |  | ) |

Get the current temperature setting.

Returns
  The current setting for temp. in degrees celsius.

## ◆ getTimer()

uint8_t IRTrotecESP::getTimer | ( | void |  | ) |

Get the timer time in nr. of Hours.

Returns
  Nr. of Hours.

## ◆ off()

void IRTrotecESP::off | ( | void |  | ) |

Set the requested power state of the A/C to off.

## ◆ on()

void IRTrotecESP::on | ( | void |  | ) |

Set the requested power state of the A/C to on.

## ◆ send()

void IRTrotecESP::send | ( | const uint16_t | repeat = `kTrotecDefaultRepeat` | ) |

Send the current internal state as an IR message.

Parameters

  [in] | repeat | Nr. of times the message will be repeated.

## ◆ setMode()

void IRTrotecESP::setMode | ( | const uint8_t | mode | ) |

Set the operating mode of the A/C.

Parameters

  [in] | mode | The desired operating mode.

## ◆ setPower()

void IRTrotecESP::setPower | ( | const bool | on | ) |

Change the power setting.

Parameters

  [in] | on | true, the setting is on. false, the setting is off.

## ◆ setRaw()

void IRTrotecESP::setRaw | ( | const uint8_t | state[] | ) |

Set the internal state from a valid code for this protocol.

Parameters

  [in] | state | A valid code for this protocol.

## ◆ setSleep()

void IRTrotecESP::setSleep | ( | const bool | on | ) |

Set the Sleep setting of the A/C.

Parameters

  [in] | on | true, the setting is on. false, the setting is off.

## ◆ setSpeed()

void IRTrotecESP::setSpeed | ( | const uint8_t | fan | ) |

Set the speed of the fan.

Parameters

  [in] | fan | The desired setting.

## ◆ setTemp()

void IRTrotecESP::setTemp | ( | const uint8_t | celsius | ) |

Set the temperature.

Parameters

  [in] | celsius | The temperature in degrees celsius.

## ◆ setTimer()

void IRTrotecESP::setTimer | ( | const uint8_t | timer | ) |

Set the timer time in nr. of Hours.

Parameters

  [in] | timer | Nr. of Hours. Max is `kTrotecMaxTimer`

## ◆ stateReset()

void IRTrotecESP::stateReset | ( | void |  | ) |

Reset the state of the remote to a known good state/sequence.

## ◆ toCommon()

stdAc::state_t IRTrotecESP::toCommon | ( | void |  | ) |

Convert the current internal state into its stdAc::state_t equivalent.

Returns
  The stdAc equivalent of the native settings.

## ◆ toCommonFanSpeed()

stdAc::fanspeed_t IRTrotecESP::toCommonFanSpeed | ( | const uint8_t | spd | ) |

static

Convert a native fan speed into its stdAc equivalent.

Parameters

  [in] | spd | The native setting to be converted.

Returns
  The stdAc equivalent of the native setting.

## ◆ toCommonMode()

stdAc::opmode_t IRTrotecESP::toCommonMode | ( | const uint8_t | mode | ) |

static

Convert a native mode into its stdAc equivalent.

Parameters

  [in] | mode | The native setting to be converted.

Returns
  The stdAc equivalent of the native setting.

## ◆ toString()

String IRTrotecESP::toString | ( | void |  | ) |

Convert the current internal state into a human readable string.

Returns
  A human readable string.

## ◆ validChecksum()

bool IRTrotecESP::validChecksum | ( | const uint8_t | state[],
|  | const uint16_t | length = `kTrotecStateLength`
| ) |  |

static

Verify the checksum is valid for a given state.

Parameters

  [in] | state | The array to verify the checksum of.
  [in] | length | The length/size of the array.

Returns
  true, if the state has a valid checksum. Otherwise, false.

## Member Data Documentation

## ◆ _irsend

IRsend IRTrotecESP::_irsend

private

Instance of the IR send class.

## ◆ remote_state

uint8_t IRTrotecESP::remote_state[kTrotecStateLength]

private

Remote state in IR code form.

The documentation for this class was generated from the following files:

- src/ir_Trotec.h
- src/ir_Trotec.cpp